XPipe 14 is the biggest rework so far and provides an improved user experience, better team features, performance and memory improvements, and fixes to many existing bugs and limitations. It will take some days until the initial rough edges are ironed out, but it will get there eventually. So please make sure to report any issues you find, even the small ones.

## Team vaults + Reusable identities

You can now create reusable identities for connections instead of having to enter authentication information for each connection separately. This will also make it easier to handle any authentication changes later on, as only one config has to be changed.

Furthermore, there is a new encryption mechanism for git vaults, allowing multiple users to have their own private connections and identities in a shared vault by encrypting them with the personal key of the user.

You can combine the reusable identities with the new per-user encryption. Essentially, if you mark a certain identity as being for your user only, it will be encrypted with your personal key and won't be accessible to other team users that have access to the vault without knowing your secret. Any connection that uses this per-user identity, will also be encrypted with your personal secret key, also making them only accessible to you. That way you can control who has access to which connections and login information in your team. You can of course also set identities to be global, so that all team users can utilize them.

If you have previously used a custom vault passphrase to lock your vault, this will be migrated to a user account with that passphrase as its secret. If you have not used that before, you can create your own user in the settings menu. Having multiple vault users requires the Professional plan but team vaults are available for free for two weeks after release.

## Incus support

- There is now support for incus
- The newly added features for incus have also been ported to the LXD integration

## Services

- There is now the option to specify a URL path for services that will be appended when opened in the browser
- You can now specify the service type instead of always having to choose between http and https when opening it
- Services for containers can now be refreshed from a dedicated button instead of a fixed services entry, saving some vertical display space
- Services now show better when they are active or inactive
- The custom service creation has been moved to the top level to make it easier to locate

## File transfers

- You can now abort an active file transfer. You can find the button for that on the bottom right of the browser status bar
- File transfers where the target write fails due to permissions issues or missing disk space are now better cancelled

## Git vault

- XPipe will now commit a dummy private key to your repository to make your git provider potentially detect any leaks of your repository contents
- Any keys committed to the repository will now be forced to LF to prevent issues with keys generated on Windows
- XPipe will now explicitly configure the setting `pull.rebase` for the local git repository as having that set to `rebase` globally would break the git sync

## Other

- Improve RAM usage
- Implement performance improvements for local shells
- The Windows Terminal integration will now create and use its own profile to prevent certain settings from breaking the terminal integration
- Future updates on Windows will be faster
- There is now the option to censor all displayed contents, allowing for a more simple screensharing workflow for XPipe
- Implement startup speed improvements
- The file browser selected file arguments for scripts are now passed in order of selection time, allowing for more advanced scripting
- Improve error messages when VMs could not be reached due to a custom firewall setup
- The XPipe [Python API](https://github.com/xpipe-io/xpipe-python-api) is now featured more prominently
- Launched terminals are now automatically focused after launch
- Add support for Ghostty on Linux
- The webtop docker image is now also available for arm64 platforms
- The webtop is now also available for Kasm Workspaces at https://github.com/xpipe-io/kasm-registry
- The Yubikey PIV and PKCS#11 SSH auth option have been made more resilient for any PATH issues
- Add translations for Swedish, Polish, Indonesian
- Add more docs to the password manager settings
- Improve error message for libvirt when user was missing group permissions

## Fixes

- Fix password manager requests not being cached and requiring an unlock every time
- Fix connection icon being removed when the connection is edited
- Fix Windows updates breaking pinned shortcuts and some registry keys (This will only work in future updates from now on)
- Fix Yubikey PIV and other PKCS#11 SSH libraries not asking for pin on macOS
- Fix launched terminal not getting focus again after a password prompt
- Fix some container shells not working do to some issues with /tmp
- Fix fish shells launching as sh in the file browser terminal
- Fix zsh terminal not launching in the current working directory in file browser
- Fix unrecognized \r showing up in various error messages
- Fix sudo elevation not working properly in VMs
- Fix permission denied errors for script files in some containers
- Fix API not respecting category field when adding connections
- Fix some files names that required escapes not being displayed in file browser
- Fix special Windows files like OneDrive links not being shown in file browser
- Fix built-in services like the Proxmox dashboard also counting for the service license limit
- Fix titlebar on Windows 11 being overlapped in fullscreen mode
